<template>
    <div class="container-fluid">
        <div class="title-nav">
            <img src="../assets/teilnehmerin.png" alt="" class="titel-logo" >
        </div>
        <div class="card-container" @submit.prevent="postTeilnehmerIn">
            <div class="card-head">
                <div class="container-fluid">
                    <div class="row gx-1 justify-content-between">
                        <div class="col-lg-1 col-md-3 arrow-container">
                            
                        </div>

                        <div class="col-lg-2 col-md-3">
                            <form><input type="text"  v-model="neueTeilnehmerIn.name" placeholder="Name" /></form>
                        </div>

                        <div class="col-lg-2 col-md-3">
                            <form><input type="text" v-model="neueTeilnehmerIn.emailAdresse" placeholder="Email"></form>
                        </div>

                        <div class="col-lg-2 col-md-3">
                            <form >
                                <select name="ks" v-model="neueTeilnehmerIn.kursStart">
                                    <option disabled >Kursstart</option>
                                    <option value="JÄNNER">Jänner</option>
                                    <option value="FEBRUAR">Februar</option>
                                    <option value="MÄRZ">März</option>
                                    <option value="APRIL">April</option>
                                    <option value="MAI">Mai</option>
                                    <option value="JUNI">Juni</option>
                                    <option value="JULI">Juli</option>
                                    <option value="AUGUST">August</option>
                                    <option value="SEPTEMBER">September</option>
                                    <option value="OKTOBER">Oktober</option>
                                    <option value="NOVEMBER">November</option>
                                    <option value="DEZEMBER">Dezember</option>
                                </select>
                            </form>
                        </div>

                        <div class="col-lg-2 col-md-3">
                            <form >
                                <select name="ke" v-model="neueTeilnehmerIn.kursEnde">
                                    <option disabled >Kursende</option>
                                    <option value="JÄNNER">Jänner</option>
                                    <option value="FEBRUAR">Februar</option>
                                    <option value="MÄRZ">März</option>
                                    <option value="APRIL">April</option>
                                    <option value="MAI">Mai</option>
                                    <option value="JUNI">Juni</option>
                                    <option value="JULI">Juli</option>
                                    <option value="AUGUST">August</option>
                                    <option value="SEPTEMBER">September</option>
                                    <option value="OKTOBER">Oktober</option>
                                    <option value="NOVEMBER">November</option>
                                    <option value="DEZEMBER">Dezember</option>
                                </select>
                            </form>
                        </div>

                        <div class="col-lg-2 col-md-3">
                            <form >
                                <select name="gr" v-model="neueTeilnehmerIn.gruppe">
                                    <option value="">Keine Gruppe</option>
                                    <option v-for="(gruppe, id) in alleGruppen" :key="id" >{{gruppe.gruppenname}}</option>
                                </select>
                            </form>
                            
                        </div>
                        <div class="col-lg-1 col-md-3 add-del-container">
                            <div class="plus-container" >
                                <span class="plus" @click="postTeilnehmerIn(neueTeilnehmerIn)">+</span>
                            </div>
                            
                        </div>
                </div>
            </div>
        </div>
            
        </div>

        <!-- Alle TeilnehmerInnen -->
        <div class="card-container alle-TrainerInnen trainerset"  v-for="(teilnehmerIn, id) in alleTeilnehmerInnen" :key="id">
            <div class="card-head">
                <div class="container-fluid">
                    <div class="row gx-1 justify-content-between">
                        <div class="col-lg-2 col-md-3 arrow-container teilnehmerInrepos">
                            <span class=" floppy" @click="manipTeilnehmerIn(teilnehmerIn)">&#128427;</span>
                        </div>

                        <div class="col-lg-2 col-md-3">
                            <div class="title-TrainerInnen-container"><span class="col-titles">Name</span></div>
                            <form><input type="text"  v-model="teilnehmerIn.name" placeholder="Name" /></form>
                        </div>

                        <div class="col-lg-2 col-md-3 email-input">
                            <span class="col-titles">Email</span>
                            <form><a :href="'mailto:'+teilnehmerIn.emailAdresse" target="_blank" class="mail">&#9993;</a> <input type="text" v-model="teilnehmerIn.emailAdresse" placeholder="Email"></form>
                        </div>

                        <div class="col-lg-2 col-md-3">
                            <span class="col-titles">Kursstart</span>
                            <form >
                                <select name="ke" v-model="teilnehmerIn.kursStart">
                                    <option value="JÄNNER">Jänner</option>
                                    <option value="FEBRUAR">Februar</option>
                                    <option value="MÄRZ">März</option>
                                    <option value="APRIL">April</option>
                                    <option value="MAI">Mai</option>
                                    <option value="JUNI">Juni</option>
                                    <option value="JULI">Juli</option>
                                    <option value="AUGUST">August</option>
                                    <option value="SEPTEMBER">September</option>
                                    <option value="OKTOBER">Oktober</option>
                                    <option value="NOVEMBER">November</option>
                                    <option value="DEZEMBER">Dezember</option>
                                </select>
                            </form>
                        </div>

                        <div class="col-lg-2 col-md-3">
                            <span class="col-titles">Kursende</span>
                            <form >
                                <select name="ke" v-model="teilnehmerIn.kursEnde">
                                    <option value="JÄNNER">Jänner</option>
                                    <option value="FEBRUAR">Februar</option>
                                    <option value="MÄRZ">März</option>
                                    <option value="APRIL">April</option>
                                    <option value="MAI">Mai</option>
                                    <option value="JUNI">Juni</option>
                                    <option value="JULI">Juli</option>
                                    <option value="AUGUST">August</option>
                                    <option value="SEPTEMBER">September</option>
                                    <option value="OKTOBER">Oktober</option>
                                    <option value="NOVEMBER">November</option>
                                    <option value="DEZEMBER">Dezember</option>
                                </select>
                            </form>
                        </div>

                        <div class="col-lg-2 col-md-3">
                            <span class="col-titles">Gruppe</span>
                            <form >
                                <select name="vb" v-model="teilnehmerIn.gruppe.id">            
                                    <option :value="teilnehmerIn.gruppe.id">{{teilnehmerIn.gruppe.gruppenname}}</option>
                                    
                                </select>
                            </form>
                            
                        </div>
                        <div class="col-lg-2 col-md-3 add-del-container">
                            <div class="teilnehmerInrepos minus-container">
                                <span class="minus"  @click="deleteTeilnehmerIn(teilnehmerIn.teilnehmerId)">-</span>
                            </div>
                            
                        </div>
                </div>
            </div>
        </div>
             
        </div>

        
            
        
    </div>
</template>

<script>


    export default{
        data() {
            return {
                teilnehmerInnenUpdate: {
                    name: "",
                    emailAdresse: "",
                    kursStart: "",
                    kursEnde: "",
                    gruppenname: "",
                    teilnehmerId: "",
                },
                neueTeilnehmerIn: {
                    name: null,
                    emailAdresse: null,
                    kursStart: "Kursstart",
                    kursEnde: "Kursende",
                    gruppenname: "Keine Gruppe",
                }
            };
        },
        computed: {
            alleTeilnehmerInnen() {
                return this.$store.state.alleTeilnehmerInnen;
            },
            TeilnehmerInnenById() {
                return this.$store.state.TeilnehmerInnenById;
            },
            alleGruppen() {
                return this.$store.state.alleGruppen;
            },
            gruppeById() {
                return this.$store.state.gruppeById;
            },
        },
        methods: {

            async getGruppeById(id) {
                this.$store.dispatch("getGruppeById", id);
            },
            postTeilnehmerIn(){
                console.log(this.postTeilnehmerIn)
                const response = this.$store.dispatch('postTeilnehmerIn', this.neueTeilnehmerIn)
                .then((result) => {
                    console.log(result)
                    console.log(response)
                })
                this.$store.commit("unshiftAlleTeilnehmerInnen", this.neueTeilnehmerIn)

                this.neueTeilnehmerIn = {
                    name: null,
                    emailAdresse: null,
                    kursStart: null,
                    kursEnde: null,
                    gruppenname: null,
                    id: '',
                }
                
            },
            
            async getTeilnehmerInnenById(id) {
                this.$store.dispatch("getTeilnehmerInnenById", id);
            },
            async deleteTeilnehmerIn(id) {
                const deleteTeilnehmerIn = this.$store.dispatch("deleteTeilnehmerIn", id);
                console.log(deleteTeilnehmerIn);
            },
            async manipTeilnehmerIn(teilnehmerInnenById) {
                this.teilnehmerInnenUpdate.name = teilnehmerInnenById.name;
                this.teilnehmerInnenUpdate.emailAdresse = teilnehmerInnenById.emailAdresse;
                this.teilnehmerInnenUpdate.kursStart = teilnehmerInnenById.kursStart;
                this.teilnehmerInnenUpdate.kursEnde = teilnehmerInnenById.kursEnde;
                this.teilnehmerInnenUpdate.gruppe.gruppenname = teilnehmerInnenById.gruppe.gruppenname;
                this.teilnehmerInnenUpdate.teilnehmerId = teilnehmerInnenById.teilnehmerId;
                this.$store.dispatch("putTeilnehmerIn", this.teilnehmerInnenUpdate);
            },
            async putTeilnehmerIn() {
                const response = this.$store.dispatch("putTeilnehmerIn", this.teilnehmerInnenUpdate);
                console.log(response);
                console.log(this.teilnehmerInnenUpdate);
            }
        },
        mounted() {
            this.$store.dispatch("getAlleTeilnehmerInnen");
            this.$store.dispatch("getAlleGruppen");
        },
        components: {  }
};    

</script>

